[V2.X.X.X]
1. Add RT3593 PCIe support.
2. Add RT3593 STA.

[V2.4.0.0]
1. Fix issue: No McuCmdLock initialization for RT3592/RT3390.
2. Add RT3592 PCIe chip ID.
3. Fix issue: error link list usage in 11r ric module in station mode.
4. Add an ATE command for AUTOALC.
5. Add an ATE command for interpacket GAP.
6. Add an ATE command for ATE payload pattern.
7. Fix issue: some reports from Prevent software analysis tool.
8. Fix WPS issue: some PIN cannot set successfully.(ex. 89134498)
9. Fix issue: STA send null frame with QoS field when STA connected to non-WMM AP.
10. Suport RFKILL: DO NOT set HAS_RFKILL_HW_SUPPORT=y in config.mk if device doesn't have HW radio on/off button.
11. Reduce data packets lost while doing scan if STA already connects to AP.
12. Fix issue: If there are two APs with same SSID and security mode but have different WPAPSK, 
			   STA may always connect to AP with different WPAPSK if the RSSI of that AP is better than the correct one.
13. Support TxRx ring PRE-ALLOC in probe stage: set RESOURCE_PRE_ALLOC=y in config.mk.
14. Shorten the connection time when interface up.
15. Fix Adhoc issue: If there are more than 2 peers exist, driver didn't delete peer from entry table unless all peers left.
16. Update rt2860.bin: for fixing the 5G band RSSI loss in LED MODE 6/7/8/9/b/c.
17. Fix issue: Correct RSSI, SNR, Noise calculations
18. Fix issue: STA cannot connect to OPEN-WEP AP if WpaSupplicant set WEPAUTO(IW_AUTH_ALG_SHARED_KEY | IW_AUTH_ALG_OPEN_SYSTEM) to driver.
19. Fixed Ad-hoc issue: STA didn't use legacy rate when STA is Ad-hoc creator and security is OPEN-WEP or WPAPSK-TKIP.

[2.3.0.0]
1. Support PSP XLINK in ad-hoc mode.
2. Add CFG80211 iw utility other commands support (supports Linux 2.6.32).
3. Fix issue: The start address of HeaderBuf must be aligned by 4 when
   VENDOR_FEATURE1_SUPPORT is enabled.
4. Fix issue: sometimes rt2860_interrupt() will be called before rt28xx_init()
   in fedora core 7.
5. WMM ACM: see history of acm_comm.c.
6. Fix issue in 64bit CPU:
	(1) WMM ACM: see history of acm_comm.c.
	(2) Fix function RTMP_MapChannelID2KHZ().
7. Support WpaSupplicant(v0.6.9) WPS
8. Fix WPS issue: Check SelectRegistrar is TRUE or FALSE
9. Fix WPS issue: Some AP (ex. Buffalo WZR-AG300NH) would change SSID to another SSID after push WPS PBC button.
				  After WPS process finish, change SSID to original SSID.
				  Driver needs to wait AP to re-generate Beacon; otherwise, driver will update this PBC SSID to MlmeAux.
10. Fix statistics issue: It happened in big-endian platform, tx count would be zero.
11. Support WiFi Draft_3.0 11n test items.
12. Support Linux Kernel 2.6.31/2.6.32.
13. Support Ad-hoc WPS2PSK/AES (DPO doesn't support this item)
14. For GPL issue: Separate three kernel modules - util module, driver module, netif module. util module and netif module could license GPL.
				   Driver module couldn't license GPL.

[V2.2.0.0]
1. Fixed issue of showing wrong statistics value.
2. Fixed problem of showing wrong SNR in wireless extension scan list.
3. Fixed WPA2PSK failed with some AP if key length is not zero in pairwise_msg_2 and pairwise_msg_4.
4. Add HAS_STATS_COUNT compile option.
5. Support TDLS.
6. Support Client WDS.
7. Support WMM ACM (Pass WiFi Test Plan v0.30).
8. Support the MAC assignment from configuration file(.dat).
9. Support Ethernet Convert in Ad-hoc mode.
10. Fixed STA cannot do WPS with AP when auth mode of STA is shared.
11. Support SKU.

[V2.1.2.0]
>> DPA/DPB/DPC/DPD
1. Short GI sampling improvement.
2. Support Linux Kernel 2.6.29
3. Fixed driver would send zero IWEVASSOCREQIE to Native WpaSupplicant.
4. Fixed driver would send non-zero BSSID to Navtive WpaSupplicant when STA disconnecting to AP.
5. Check Addr1, Addr2 and Addr3 of de-auth packet from AP (driver only checked Addr2 of de-auth packet before).

[V2.1.2.0]
>> DPO
1. Short GI sampling improvement.
2. Check Addr1, Addr2 and Addr3 of de-auth packet from AP (driver only checked Addr2 of de-auth packet before).

[V2.1.1.0]
>> Only DPO project has this version
1. Fixed driver would send zero IWEVASSOCREQIE to Native WpaSupplicant.
2. Fixed driver would send non-zero BSSID to Navtive WpaSupplicant when STA disconnecting to AP.
3. Support 2.6.29

[V2.1.0.0]
1. New generation schema for multiple OS porting
2. New chip support for RT3562/RT3062/RT3592
3. Fixed Ad-hoc ping failed in noisy environment. (Probe Response has too many retry packet then cause "not enough space in MgmtRing")
4. Fixed WPA(2)PSK issue when group cipher of AP is WEP40 or WEP104.
5. Modified iwpriv ra0 get_site_survey: 
	In scan list result: Security shows "NONE" when AP is OPEN/NONE,
								  shows "WEP"  when AP is OPEN/WEP or SHARED/WEP,
								  shows "WPAPSK(WPA2PSK)/TKIP(AES)" when AP is WPAPSK(WPA2PSK)/TKIP(AES)
								  shows "WPA(WPA2)/TKIP(AES)" when AP is WPA(WPA2)/TKIP(AES)
6. Fixed WPS failed with D-Link DIR-628 in 5GHz.
7. When cipher is WEP or TKIP, STA would connect to 11N AP with legacy rate.
	"iwpriv ra0 set HtDisallowTKIP=val": Enable/Disable N rate with 11N ap when cipher is WEP or TKIP.
	val: 
		0 : FALSE
		1 : TRUE
	Default setting is disable.
8. Add "iwpriv ra0 wsc_ap_band val" command for setting prefer band to do WPS with dual band WPS AP.
	val:
        0 : prefer 2.4G
        1 : prefer 5G
        2 : auto
	Default value is auto (2) 
9. Add "iwpriv ra0 set BeaconLostTime=val" command for user to change Beacon Lost Time.
	val:
		1 ~ 60 seconds
	Default value is 4 seconds
10. Change FastRoaming in DAT file to AutoRoaming.
	Add "iwpriv ra0 set AutoRoaming=val" command for user to enable/disable auto roaming mechanism.
		0 : disable
		1 : enable
	Default setting is disable.
11. Support kthread.
12. Add "iwpriv ra0 set SiteSurvey=val" command for user to scan with specific SSID after Link Up.
	val:
		0~z, 1~32 ascii characters
13. Add New A band channel list region 15 contains the whole channels in the A band region 4 and the new CE channel 167,169,171,173.
14. New IEEE802.11r functionality.
15. Fixed WPA2-Enterprise failed when AP reboot or turn off then turn on.
16. Fixed STA cannot connect to 11B only AP when the setting of is PHY_11GN.
17. Support Linux Kernel 2.6.28 & 2.6.29 (only 3062 V2.1.0.0 supports this item)

[V2.0.1.0]
1. fix eFuse bug on big-endian platform
2. fix WMM problem for RT3091/92
3. fix one bug for ATE TX power handling and ATE frequency offset bug.
4. fix mesh crash issue
5. fix RT309x AMPDU throughput bug after interface down/up
6. fix RT309x PCI-E compatibility issue.
7. fix RT309x difficult to enter power save mode issue.
8. fix a bug that is hard to connect with hidden-SSID AP.

[V2.0.0.0]
1. Support new chips RT3090/91/92.
2. Lots of patch and bug fix from last release.
3. Support eFuse.
4. Support Antenna Diversity for RT3070.

[1.8.0.0]
1. Fixed compile error when CARRIER_DETECTION_SUPPORT is enabled.
2. Add "iwpriv ra0 set CarrierDetect=0(or 1)"
3. Add new WSC hardware push button function
4. Add Ad-Hoc to support N rate.
5. Migrate Mesh supporting to Draft-2.0.
6. Support WAPI functionality
7. Fixed suspend/resume error when ra0 down, ra0 up.
8. Support Linux Kernel 2.6.27
9. Fixed WPS failed when AP is not in scan table or AP's channel changing after user sets "iwpriv ra0 wsc_start"
10. Fixed DLS A-MPDU established failed.

[1.7.0.0]
1. Support SIOCSIWGENIE, SIOCGIWGENIE, SIOCSIWMLME, SIOCGIWENCODEEXT, and SIOCSIWPMKSA.
2. Support IWEVGENIE in iwlist ra0 scan.
3. Support DLS
4. Fixed connection failed with Range Maximizer - 515 AP (Marvell Chip) when security is WPAPSK/TKIP.
5. Fixed length error of RSN/SSN IE for WpaSupplicant.
6. Fixed WPAPSK rekey problem when A-MSDU is enabled.
7. Fixed NetworkManager cannot detect ra0 when ra0 is not up.
8. Add IEEE802.11d Client Mode: None, Flexible, Strcit.
9. Add Station N only mode. (Only connects to N-AP)
10. Add Global country domain(ch1-11:active scan, ch12-14 passive scan)
11. Enhance PCIe advance power saving
12. Modified iwpriv ra0 get_site_survey: When security of AP is OPEN/WEP or SHARED/WEP, show UNKNOW/WEP in scan list.
13. When the secondary channel of AP exceeds the country region's range, station will auto fallback to 20MHz. i.e. need both control and secondary channel are both
	in country region's channel list.
14. Fixed crash in LinkDown when there are >64 APs exists.

[V1.6.2.0]
>> Only DPO project has this version
1. Enhance PCIe advance power saving.
2. Update rt2860.bin for PCIe advance power saving.
3. Fixed length error of RSN/SSN IE for WpaSupplicant.
4. Add vendor ID and device ID for EEEPC(VEN_AWT_PCIe_DEVICE_ID	0x1059, VEN_AWT_PCI_VENDOR_ID	0x1A3B)

[V1.6.1.1]
>> Only DPO project has this version
1. Fixed connection failed with Range Maximizer - 515 AP (Marvell Chip) when security is WPAPSK/TKIP

[V1.6.1.0]
1. Init MAC register 0x1204 to 0x3

[V1.6.0.0]
1. Fixed issue of Radar Channel flag building with HAS_EXT_BUILD_CHANNEL_LIST=n.
2. Fixed issue of Adhoc-STA would create in radar channel.
3. Support Mesh
4. Support Linux Kernel 2.6.24
5. Support SNMP
6. Support Debug Diagnose
7. Add Makefile.NonLoadableModule for non-loadable module
8. Add two ioctl commands to change tx long/short retry limit.
9. Fixed WPS STA is hard to do WPS process with Broadcom WPS AP Proxy and Marvell WPS External Registrar.

[V1.5.0.0]
1. New code base - RT28xx.
2. Add BaSmartHardTransmit mechanism.
3. Support Linux Kernel 2.6 suspend and resume.
4. Support extened channel list.
5. Add "iwconfig rate" setting for legacy rate.
6. Add make install/uninstall to Makfile.
7. Fixed issue of showing SNR1 information.
8. ATE: Add command "iwpriv ra0 set ATELDE2P=1" to overwrite all EEPROM contents from a .bin file.
9. Change IRQ LOCK to SEM LOCK
10. Support Non-GPL MD5

[V1.4.0.0]
1. Fixed Legacy Wi-Fi WMM S06 fail.
2. Fixed WPAPSK failed when 2860 STA Aggregation is enabled and connects with 2860 N/Aggregation AP. 
3. Fixed "iwconfig ra0 essid"
4. Send DIS-ASSOC request to AP when ra0 down.
5. Support 5-GHz band ATE.
6. Fixed fixed rate issue in N mode and fixed rate ioctl.
7. Add Legacy Power Saving Mode.
8. Fixed W52 with Activity scan issue in ABG_MIXED and ABGN_MIXED mode.
9. Fixed ping failed with Broadcom N AP when AP is GF enabled and STA is auto rate.
10. Support custom wireless event.
11. Modify rate adaptation for fast ramp-up tuning. 

[V1.3.0.0]
1. Support Monitor Mode with WireShark.(Usage: iwconfig ra0 mode monitor)
2. Update Rate Adaptation Algorithm.
3. Add ATE function(also QA supported).
4. Support IPv6 Ethernet Convert Mechanism.
5. Support NetworkManager, wpa_supplicant by using wext.
6. Fixed Auto Rate Select issue.(When RT2860 Linux STA links up with N-AP then chaged to link up with legacy-AP)
7. Fixed Fast-Roaming Fail Issue.

[V1.2.1.0]
1. Fixed segmentation fault when size of iwpriv ra0 get_site_survey result exceeded 4096.
2. Add MAT related iwpriv commands.
3. Add AP's wireless mode info to iwpriv ra0 get_site_survey.
4. Modify bitrate info in iwlist ra0 scan.

[V1.2.0.0]
1. Update NicConfig2 default value.
2. Modify STA to retrieve the MCS of AP(from Beacon) and save to StaActive structure.
3. Add WPS re-generate PIN command: iwpriv ra0 wsc_gen_pincode.
4. Do NOT re-build M-messages in WPS state machine timeout timer function.
5. Fixed compile error in non-DBG mode.

[V1.1.0.0]
1. Fixed WI-FI test item 5.2.2.9 #S7, STA will fail to authenticate when AP set fragmentation to 500.
2. Fxied iwpriv security setting issue.
3. Re-organize the Rx data path.
4. Update Tx Power mechanism.
5. Support WPS In-band(EAP) & Out-Of-band(UPnP) Enrollee mode and In-band(EAP) Registrar mode.
6. Add WPS related iwpriv commands
7. Support Dongle/Clone/Dongle+Clone mechanism
8. Support Big-Endian.

[V1.0.0.0]
1. Chariot Throughput ok
2. Driver security support: Open/Shared WEP, WPA-PSK, WPA2-PSK, WPA-NONE.
3. Support 32/64-bit OS
4. Support A-MPDU and A-MSDU
